#include <phigs.h>			/* get HP-PHIGS definitions for C */
#include <stdio.h>			/* get standard I/O definitions */
#include <math.h>			/* link with library "-lm" */

main()					/* file "jaws2.c" */
{
    Pint		WorkstnID = 1;		/* workstation identifier */
    Pint		ConnID;			/* connection identifier */
    Pint		WorkstnType = POIDDX;	/* out/in, dir, dbl bfr, X */
    Pint		TheStructure = 1;	/* structure ID */
    /*--- define curve 1 ---------------------------------------------------*/
    static Pfloat	KnotVals1[9] =
	{0.0, 0.0, 0.0, 1.0, 2.0, 3.0, 4.0, 4.0, 4.0};
    static Ppoint3	CtrlPts1[6] = {{0.1, 0.1, 0.0}, {0.7, 0.1, 0.0},
	{0.9, 0.1, 0.0}, {0.9, 0.3, 0.0}, {0.7, 0.3, 0.0}, {0.6, 0.3, 0.0}};
    static Pcurve_geom_spline	Curve1 = {
	3,					/* spline order */
	{9, KnotVals1},				/* knot vector */
	0.0, 4.0,				/* low/high limits */
	{PB_SPLINE_NON_RATIONAL, 6, CtrlPts1}};	/* list of control points */
    /*--- define curve 2 ---------------------------------------------------*/
    static Pfloat	KnotVals2[6] =
	{0.0, 0.0, 0.0, 1.0, 1.0, 1.0};
    static Ppoint3	CtrlPts2[3] = {{0.6, 0.3, 0.0}, {0.55, 0.25, 0.0},
	{0.5, 0.2, 0.0}};
    static Ppoint_list3	Markers2 = {3, CtrlPts2};
    static Pcurve_geom_spline	Curve2 = {
	3,					/* spline order */
	{6, KnotVals2},				/* knot vector */
	0.0, 1.0,				/* low/high limits */
	{PB_SPLINE_NON_RATIONAL, 3, CtrlPts2}};	/* list of control points */

    popen_phigs((char *) stderr, 0);	/* errors go to "stderr" */
    pescape_u4("/dev/screen/phigs_window", &ConnID);
    popen_ws(WorkstnID, (void *) ConnID, WorkstnType);
    popen_struct(TheStructure);
    pset_marker_type(PMARKER_ASTERISK);
    pset_marker_size(4.0);
    /*--- draw curve 1 -----------------------------------------------------*/
    pset_linetype(PLINE_DASH);
    pnon_uniform_b_spline_curve3(&Curve1);
    /*--- draw curve 2 -----------------------------------------------------*/
    pset_linetype(PLINE_SOLID);
    ppolymarker3(&Markers2);
    pnon_uniform_b_spline_curve3(&Curve2);
    pclose_struct();
    ppost_struct(WorkstnID, TheStructure, 1.0);
    pupd_ws(WorkstnID, PFLAG_PERFORM);
    pclose_ws(WorkstnID);
    pclose_phigs();
}
